#include <cstdlib>
#include <iomanip>
#include <iostream>
#include "math.h"

#include <cuda_runtime.h>

#include "integral.h"


int main()
{
    // .
    float a = 0.0f, b = 1.0f; // a <= x <= b
    int n = 100000; //  
    float h = (b - a) / (float)n; //  
    int num_blocks = 8; //    GPU

    float result_CPU = 0.0f;
    float result_GPU = 0.0f;

    //  CPU-.
    result_CPU = integral(a, n, h);

    //  GPU-.
    result_GPU = integral_gpu(a, n, h, num_blocks);

    //  ,      .
    const float eps = 1e-4f;
    if (fabsf(result_CPU - result_GPU) < eps)
        std::cout << "Test PASSED.\n";
    else
        std::cout << "Test FAILED.\n";

    return 0;
}
